﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" %>

<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
	<title>Untitled Page</title>
</head>
<body>
    <script type="text/javascript">
        /* <![CDATA[ */
		var gridId = "<%= RadGrid1.ClientID %>";
				
        //Handles the OnNodeDropping event of RadTreeView.
        function onNodeDropping(sender, args)
		{			
		    var dest = args.get_destNode();
		    
			if (dest)
			{ 
			    //Handle dropping on a Node if required.
			}
			else
			{ 
				dropOnHtmlElement(args);
			}
		}
		
		//Handles the case when a Node is dropped onto an HTML element.
		function dropOnHtmlElement(args)
		{					
		    if(droppedOnGrid(args))
		        return;					
		}
		
		//Checks whether a Node is being dropped onto the RadGrid with ID: 'gridId'.
		//If not, the OnClientDropping event is canceled. 
		function droppedOnGrid(args)
		{
		    var target = args.get_htmlElement();
		    
		    while(target)
		    {
		        if(target.id == gridId)
		        {
		            args.set_htmlElement(target);
		            
		            return;				            				            				            
		        }
		        
		        target = target.parentNode;
		    }
		    
		    args.set_cancel(true);
		}
		/* ]]> */
    </script>
	<form id="form1" runat="server">
		<asp:ScriptManager runat="server" ID="ScriptManager1">
		</asp:ScriptManager>
		<telerik:RadAjaxManager runat="server" ID="RadAjaxManager1" OnAjaxRequest="RadAjaxManager1_AjaxRequest">
			<AjaxSettings>
				<telerik:AjaxSetting AjaxControlID="RadAjaxManager1">
					<UpdatedControls>
						<telerik:AjaxUpdatedControl ControlID="RadTreeView1" />
						<telerik:AjaxUpdatedControl ControlID="RadGrid1" />
					</UpdatedControls>
				</telerik:AjaxSetting>
				<telerik:AjaxSetting AjaxControlID="RadTreeView1">
					<UpdatedControls>
						<telerik:AjaxUpdatedControl ControlID="RadTreeView1" />
						<telerik:AjaxUpdatedControl ControlID="RadGrid1" />
					</UpdatedControls>
				</telerik:AjaxSetting>
				<telerik:AjaxSetting AjaxControlID="RadGrid1">
					<UpdatedControls>
						<telerik:AjaxUpdatedControl ControlID="RadGrid1" />
					</UpdatedControls>
				</telerik:AjaxSetting>
			</AjaxSettings>
		</telerik:RadAjaxManager>
		<div>
			<div style="float: left; width: 20%;">
				<telerik:RadTreeView 
				    runat="server" 
				    Skin="Vista" 
				    ID="RadTreeView1" 
				    Width="200px" 
				    OnClientMouseOver="onNodeMouseOver"
					OnClientMouseOut="onNodeMouseOut" 
					OnClientNodeDropping="onNodeDropping"
					EnableDragAndDrop="True" 
					LoadingStatusPosition="BeforeNodeText" OnNodeDrop="RadTreeView1_NodeDrop">
                    <CollapseAnimation Duration="100" Type="OutQuint" />
                    <ExpandAnimation Duration="100" Type="OutQuart" />
				</telerik:RadTreeView>
			</div>
			<div style="float: left; width: 80%;">
				<telerik:RadGrid runat="server" Skin="Vista" ID="RadGrid1" OnItemCreated="RadGrid1_ItemCreated"
					GridLines="None" AllowMultiRowSelection="True" OnNeedDataSource="RadGrid1_NeedDataSource">
                    <MasterTableView>
                        <RowIndicatorColumn Visible="False">
                            <HeaderStyle Width="20px" />
                        </RowIndicatorColumn>
                        <ExpandCollapseColumn Resizable="False" Visible="False">
                            <HeaderStyle Width="20px" />
                        </ExpandCollapseColumn>
                    </MasterTableView>
                    <ClientSettings>
                        <ClientEvents OnRowMouseOver="onRowMouseOver" />
                    </ClientSettings>
				</telerik:RadGrid>
			</div>
			<telerik:RadScriptBlock runat="server" ID="RadScriptBlock1">

           <script type="text/javascript">
                /* <![CDATA[ */
                var currentDraggedRow = null;
                var dataSetIndex = null;
                var visualClue = null;
                var currentNode = null;			
                
                function onNodeMouseOver(sender, args)
                {
                    //gets the node upon mousing over the node
                    currentNode = args.get_node();
                }
                
                function onNodeMouseOut(sender, args)
                {
                    //resets the currentNode value upon mousing out
                    currentNode = null;
                }
                
                function onRowMouseOver(sender, args)
                {
                    //gets the grid to be draggaed from
                    grid = sender;
                }
                
                function onMouseDown(e, element, dataIndex)
                {
                    //Store the currently dragged row (TR)
                    currentDraggedRow = element;
                    //Store the data key value of the dragged data grid row
                    dataSetIndex = dataIndex;
    
                    //Attach events to support rendering the visual clue
                    $addHandler(document, "mousemove", mouseMove);
                    $addHandler(document, "mouseup", mouseUp);
                    
                    //Prevent selection of text while dragging
                    
                    //Internet Explorer
                    $addHandler(document, "selectstart", preventSelect);
                    
                    //Other browsers
                    if (e.preventDefault)
                        e.preventDefault();
                }
                
                function preventSelect(e)
                {
                    e.preventDefault();
                }
                
                function createVisualClue()
                {
                    var div = document.createElement("div");
                    div.style.position = "absolute";
                    div.className = $get("<%= RadGrid1.ClientID %>").className;
                    div.innerHTML = String.format("<table class='{0}'><tr>{1}</tr></table>",
                        $get("<%= RadGrid1.MasterTableView.ClientID %>").className,
                    currentDraggedRow.innerHTML);
                    
                    return div;
                }
                
                function mouseMove(e)
                {
                    if (!visualClue)
                    {
                        visualClue = createVisualClue();
                        document.body.insertBefore(visualClue, document.body.firstChild);
                    }
                    
                    visualClue.style.left = e.clientX + 10 + "px";
                    visualClue.style.top = e.clientY + 10 + "px";
                }
                
                function mouseUp(e)
                {
                    if (visualClue)
                    {
                        //Remove the visual clue
                        visualClue.parentNode.removeChild(visualClue);
                        visualClue = null;
                    }
                    //Detach the events supporting the visual clue
                    $removeHandler(document, "mousemove", mouseMove);
                    $removeHandler(document, "mouseup", mouseUp);
                    
                    //Detach the event preventing selection in Internet Explorer
                    $removeHandler(document, "selectstart", preventSelect);
                    
                    if (currentNode && currentDraggedRow)
                    {					
                        //Store the value of the node on which the mouse is over
                        $get("<%=TreeNodeText.ClientID%>").value = currentNode.get_text();
                        
                        //Store the data key value of the dragged data grid row
                        $get("<%= DataSetIndex.ClientID %>").value = dataSetIndex;				    
                        
                        
                        //Initiate AJAX request to update the page								
                        var ajaxManager = $find("<%= RadAjaxManager1.ClientID %>");
                        ajaxManager.ajaxRequest();					
                    }
                }                   
                /* ]]> */
            </script>

			</telerik:RadScriptBlock>
			<asp:HiddenField runat="server" ID="DataSetIndex" />
			<asp:HiddenField runat="server" ID="TreeNodeText" />
		</div>      
	</form>
</body>
</html>
